#ifndef _WEBCALC_H
#define _WEBCALC_H

// Some headers.
/*
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
*/
#include <stdarg.h>
#include "fxlib.h"

// Limiting constants definition.
#define CHILD_NUM	20
#define ATTRS_NUM	5

// Project headers.
#include "memory.h"
#include "libfont-3.1.h"
#include "tex-0.9.h"
#include "DOM.h"

#include <display.h>
#include <stdref.h>

// Main functions.
void init(void);
void quit(void);
int  main(void);

int RTC_ticks();

// Window functions.
void Window_init(void);
void Window_resize(uint, uint);
void Window_setHTML(struct DomElement *html_element);
const char *Window_workingDirectory(void);
void Window_setWorkingDirectory(const char *working_directory);
void Window_addStylesheet(reference_t stylesheet);
void Window_DEBUGWEB(void);
void Window_quit(void);
void Window_resolve(void);
void Window_clear(void);
extern Window *window;

// Debug stuff.
#define DEBUG_SIZ 10000
#define DEBUG_STRSIZE 100
void Debug_execute(void);
extern char Debug_buffer[DEBUG_STRSIZE+1];
void Debug(const char *format, ...);
// #define Debug(format,...) sprintf(Debug_buffer,format,##__VA_ARGS__),Debug_execute()
#define runtime_debug(str); { \
	unsigned int key; \
	SaveDisp(1); \
	dclear(); \
	locate(1,1); Print((unsigned char *)str); \
	GetKey(&key); \
	RestoreDisp(1); \
}
#define runtime_debug_ref50(ref); { \
	unsigned int key; \
	char ch[51]; \
	int i; \
	SaveDisp(1); \
	dclear(); \
	for(i=0;i<50&&i<ref.end-ref.begin;i++) ch[i] = ref.begin[i]; \
	ch[i] = 0; \
	locate(1,1); Print((unsigned char *)ch); \
	GetKey(&key); \
	RestoreDisp(1); \
}
#define runtime_debug_int(integer); { \
	unsigned int key; \
	char ch[20]; \
	itoa(integer,ch,10); \
	SaveDisp(1); \
	dclear(); \
	locate(1,1); Print((unsigned char *)ch); \
	GetKey(&key); \
	RestoreDisp(1); \
}
#define runtime_debug_ptr(ptr); { \
	unsigned int key; \
	char ch[20] = "0x"; \
	itoa((unsigned int)ptr,ch+2,10); \
	SaveDisp(1); \
	dclear(); \
	locate(1,1); Print((unsigned char *)ch); \
	GetKey(&key); \
	RestoreDisp(1); \
}

char *itoa(int n, char *str, int base);

// HTML module functions.
void html_parse(const char *code, const char *end);
void html_args(reference_t *name_or_string, reference_t *value);
void html_clear(void);

// CSS module functions.
void css_parse_all(void);
void css_parse(const char *stylesheet_data);
void css_target(reference_t selector, reference_t property, reference_t value);
int  css_matches(struct DomElement *element, reference_t target);
void css_apply(struct DomElement *element, reference_t property, reference_t value);
int  css_index(reference_t value, int strings, ...);

// Disp HTML display module functions.
void display(int offset);
void Disp_paint(struct DomElement *, int, int);
void Disp_text(struct DomElement *, int, int, int);
uint Disp_textLength(const char *, const char *, int, int);
void Disp_textDraw(const char *, const char *, struct DomStyle *, int, int,
	int);
void disp_bitmap(int x, int y, const unsigned char *b, int w, int h);

// Tools functions.
void tools_allocTracer(void);
void allocTracer_init(void);
void allocTracer_save(void);
void allocTracer_restore(void);
void allocTracer_add(int size, int category);
int  allocTracer_get(int category);

#endif // _WEBCALC_H
