/****************************************************************/
/*                                                              */
/*                            Memory                            */
/*                                                              */
/*  Description: Fonctions de manipulation de la memoire        */
/*  Auteur:      LePhenixNoir                                   */
/*  Version:     3.0                                            */
/*  Date:        11.06.2014                                     */
/*  Fichier:     memory.h - Fichier d'en-tete                   */
/*                                                              */
/****************************************************************/

#ifndef __MEMORY_H__
  #define __MEMORY_H__

  #define memory_closefile(h)       Bfile_CloseFile(h)
  #define memory_writefile(h,c,l)   Bfile_WriteFile(h,c,l)
  #define memory_readfile(h,b,s,p)  Bfile_ReadFile(h,b,s,p)
  #define memory_seekfile(h,p)      Bfile_SeekFile(h,p)
  #define memory_filesize(h)        Bfile_GetFileSize(h)
  unsigned short *memory_char2font(const char *);
  char   *memory_font2char      (unsigned short *);

  void    memory_seterrors      (int);
  void    memory_error          (const char *,const char *,int);

  int     memory_createfile     (const char *,int);
  int     memory_createdir      (const char *);
  int     memory_openfile       (const char *,int);
  int     memory_deletefile     (const char *);

  char  **memory_alloc          (int);
  void    memory_free           (char **,int);
  int     memory_find           (char *,char **,int);
  int     memory_exists         (char *);
  void   *memory_load           (char *, int *);
  int     memory_save           (char *,void *,int);

  int     memory_user_select    (char **,int,int);
  void   *memory_user_autoload  (char *,char *,int,int,int *);

#endif
