#ifndef _STDREF_H
	#define _STDREF_H 1

/*
	Header inclusions.
*/

/*
#include <string.h>
#include <stdlib.h>
*/
#include "fxlib.h"



/*
	Composed types definitions.
*/

// reference_t structure definition.
typedef struct
{
	// Beginning of referenced area. Included.
	const char *begin;
	// End of referenced area. Excluded.
	const char *end;
} reference_t;



/*
	Function prototypes.
*/

// Tests if a reference is invalid or null.
int refnull(reference_t ref);
// Extracts the referenced text in an allocated pointer.
char *refxtrct(reference_t ref);
// Unreferences the spaces at the beginning and end of the referenced area.
reference_t reftrim(reference_t ref);
// Compares a reference and a string.
int refscmp(reference_t ref, const char *str);
// Compares a reference and a string, in the limit of `length` characters.
int refsncmp(reference_t ref, const char *str, int length);

#endif // _STDREF_H
