#include "WebCalc.h"

void tools_allocTracer(void)
{
	Font *font = font_nearest(5);
	const char *messages[] = { "DOM", "Style", "Other", "Total" };
	unsigned key;
	char ch[20];
	int i;

	Bdisp_AllClr_VRAM();

	PrintXY(26,1,(const unsigned char *)"Memory usage",0);
	Bdisp_AreaReverseVRAM(0,0,127,9);

	for(i=0;i<4;i++)
	{
		int y = 16+(i<<3), j, x;
		int n = allocTracer_get(i);

		font_text(5,y,messages[i],font);
		for(j=32;j<97;j++) dpixel(j,y+3,1);
		dpixel(32,y+1,1);
		dpixel(32,y+2,1);

		for(x=0;x<4;x++,n/=10) ch[3-x] = n%10;
		ch[4] = 0;
		font_text(105,y,ch,font);

		n = n / 768 + 33;
		for(j=33;j<n;j++) dpixel(j,y+1,1), dpixel(j,y+2,1);
	}

	GetKey(&key);
}

static int allocTracerBuffer[3];
static int allocTracerSave[3];

void allocTracer_init(void)
{
	int i;
	for(i=0;i<3;i++) allocTracerBuffer[i] = 0, allocTracerSave[i] = 0;
}

void allocTracer_save(void)
{
	int i;
	for(i=0;i<3;i++) allocTracerSave[i] = allocTracerBuffer[i];
}

void allocTracer_restore(void)
{
	int i=0;
	for(i=0;i<3;i++) allocTracerBuffer[i] = allocTracerSave[i];
}

void allocTracer_add(int size, int category)
{
	allocTracerBuffer[category] += size;
}

int allocTracer_get(int category)
{
	int i, n = 0;
	if(category >= 0 && category < 3)
	{
		return allocTracerBuffer[category];
	}
	for(i=0;i<3;i++) n += allocTracerBuffer[i];
	return n;
}
